library NetMon;

uses
  windows,
  sysutils,
  Contnrs,
  plugdebug,
  classes,
  uNetMon,
  uPlUtils,
  uFileInfoCollection,
  fsplugin,
  uFSPluginClass in 'uFSPluginClass.pas',
  uNetMonPlugin in 'uNetMonPlugin.pas',
  uTimer in 'uTimer.pas';

{$R NETMicon.res}

var { Private declarations }
	CurrentFSPlugin: TNetMonFSPlugin;


function FsMkDir(RemoteDir:pchar):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsMkDir(RemoteDir);
end;

procedure InitAll;
begin
	CurrentFSPlugin := TNetMonFSPlugin.Create;
	CurrentFSPlugin.InitValues;
	CurrentFSPlugin.InitPlugin;
	Debug(FPluginTitle+' version ' + FPluginVersion, DebugOff);
	Debug('Written by Gorbush (Serg Puljajev)', DebugOff);
end;

procedure DoneAll;
begin
  try
	CurrentFSPlugin.DonePlugin;
	CurrentFSPlugin.DoneValues;
	CurrentFSPlugin.Free;
  except
	on E : Exception do
	begin
	   Messagebox(0,pchar(E.Message),'NetMon',0);
	end;
  end;
end;


{****************************************************************************}

function FsInit(PluginNr:integer;pProgressProc:tProgressProc;pLogProc:tLogProc;
				pRequestProc:tRequestProc):integer; stdcall;
begin
	if CurrentFSPlugin = nil then
		InitAll;
	Result := CurrentFSPlugin.FsInit(PluginNr,pProgressProc,pLogProc,pRequestProc);
end;

function FsFindFirst(path :pchar;var FindData:tWIN32FINDDATA):thandle; stdcall;
begin
	if CurrentFSPlugin = nil then
		InitAll;
	Result := CurrentFSPlugin.FsFindFirst(path,FindData);
end;

function FsFindNext(Hdl:thandle;var FindData:tWIN32FINDDATA):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsFindNext(Hdl,FindData);
end;

function FsPutFile(LocalName,RemoteName:pchar;CopyFlags:integer):integer; stdcall;
begin
	Result := CurrentFSPlugin.FsPutFile(LocalName,RemoteName,CopyFlags);
end;


function FsGetFile(RemoteName,LocalName:pchar;CopyFlags:Integer;  ri:pRemoteInfo):integer; stdcall;
begin
	Result := CurrentFSPlugin.FsGetFile(LocalName,RemoteName,CopyFlags,ri);
end;

function FsDeleteFile(RemoteName:pchar):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsDeleteFile(RemoteName);
end;

function FsRemoveDir(RemoteName:pchar):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsRemoveDir(RemoteName);
end;

function FsExecuteFile(MainWin:thandle;RemoteName,Verb:pchar):integer; stdcall;
begin
	Result := CurrentFSPlugin.FsExecuteFile(MainWin, RemoteName, Verb);
end;

function FsDisconnect(DisconnectRoot:pchar):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsDisconnect(DisconnectRoot);
end;

procedure FsGetDefRootName(DefRootName:pchar;maxlen:integer); stdcall;
begin
	CurrentFSPlugin.FsGetDefRootName(DefRootName,maxlen);
end;

function FsFindClose(Hdl:thandle):integer; stdcall;
begin
	Result := CurrentFSPlugin.FsFindClose(Hdl);
end;

function FsRenMovFile(OldName,NewName:pchar;Move,OverWrite:bool;RemoteInfo:pRemoteInfo):integer; stdcall;
begin
	Result := CurrentFSPlugin.FsRenMovFile(OldName,NewName,Move,OverWrite,RemoteInfo);
end;

function FsSetAttr(RemoteName:pchar;NewAttr:integer):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsSetAttr(RemoteName, NewAttr);
end;

function FsSetTime(RemoteName:pchar;CreationTime,LastAccessTime,LastWriteTime:PFileTime):bool; stdcall;
begin
	Result := CurrentFSPlugin.FsSetTime(RemoteName, CreationTime, LastAccessTime, LastWriteTime);
end;

procedure FsStatusInfo(RemoteDir:pchar;InfoStartEnd,InfoOperation:integer); stdcall;
begin
	CurrentFSPlugin.FsStatusInfo(RemoteDir, InfoStartEnd, InfoOperation);
end;

function  FsExtractCustomIcon(RemoteName:pchar;ExtractFlags:integer;var TheIcon:hicon):integer;stdcall;
begin
	Result := CurrentFSPlugin.FsExtractCustomIcon(RemoteName, ExtractFlags, TheIcon);
end;

exports
	FsExtractCustomIcon,
	FsInit,
	FsMkDir,
	FsRemoveDir,
	FsFindFirst,
	FsFindNext,
	FsFindClose,
	FsGetFile,
	FsPutFile,
	FsExecuteFile,
	FsDeleteFile,
	FsDisconnect,
	FsRenMovFile,
	FsSetAttr,
	FsSetTime,
	FsStatusInfo,
	FsGetDefRootName;

var
	SaveExit:tfarproc;

procedure LibExit;
begin
  	try
		DoneAll;
	except        {Don't let exceptions out of the DLL!}
	end;
	ExitProc := SaveExit;
end;

{$E wfx}

begin	
	SaveExit := ExitProc;
	ExitProc := @LibExit;
end.

